//
//  BiorhythmViewController.m
//  Biorhythm
//
//  Created by 유동근 on 09. 05. 11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "BiorhythmViewController.h"

@implementation BiorhythmViewController

@synthesize timeLabel;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	_timer = [NSTimer scheduledTimerWithTimeInterval:1 
											  target:self 
											selector:@selector(myMethod) 
											userInfo:nil 
											 repeats:YES];
	timeLabel.font = [UIFont boldSystemFontOfSize:16]; 
	timeLabel.shadowColor = [UIColor colorWithRed:0.0 green:0.0 blue:0.0 alpha:0.75]; 
	timeLabel.shadowOffset = CGSizeMake(-1, -1); 
	timeLabel.textAlignment = UITextAlignmentCenter; 
	timeLabel.textColor = [UIColor lightGrayColor]; 
	
	birth_year.delegate = self;
	birth_month.delegate = self;
	birth_day.delegate = self;
	birth_year.placeholder = @"년";
	birth_month.placeholder = @"월";
	birth_day.placeholder = @"일";
	birth_year.clearsOnBeginEditing = NO;
	birth_year.borderStyle = UITextBorderStyleRoundedRect;
//	birth_year.clearButtonMode = UITextFieldViewModeAlways;
	
//	button.titleShadowOffset = CGSizeMake(2, 2);
//	[button setTitle:@"계산" forState:UIControlStateHighlighted];
//	button.titleEdgeInsets = UIEdgeInsetsMake(-50, 0, 20, 0);
}

-(void)myMethod{
	NSDate* date = [_timer fireDate];
	NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
	NSLocale* locale = [[[NSLocale alloc] initWithLocaleIdentifier:@"ko_KO"] autorelease];
	[dateFormatter setLocale:locale];
//	[dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
	[dateFormatter setDateStyle:NSDateFormatterLongStyle];
	[dateFormatter setTimeStyle:NSDateFormatterLongStyle];
	[self.timeLabel setText:[dateFormatter stringFromDate:date]];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

-(IBAction)calcBiorhythm:(id)sender
{
	unsigned unitFlags = NSYearCalendarUnit | NSMonthCalendarUnit |  
						 NSDayCalendarUnit; 
	NSCalendar *calendar = [NSCalendar currentCalendar];
	NSDate *now = [NSDate date]; 
    NSDateComponents *birthDate = [[NSDateComponents alloc] init];
    NSDateComponents *currentDate = [calendar components:unitFlags
												fromDate:now];
	
	[birthDate setYear:[birth_year.text intValue]];
	[birthDate setMonth:[birth_month.text intValue]];
	[birthDate setDay:[birth_day.text intValue]];
	
	[self reCalcBiorhythmData:birthDate andCurrentDate:currentDate];
	

	for (int i = 0; i < 31 ;i++)
		NSLog (@"%d, %f\n", i, _biorhythmData[i][1]);
	NSInteger currDay = [currentDate day]-1;
	int value1 = (int)_biorhythmData[currDay][0];
	int value2 = (int)_biorhythmData[currDay][1];
	int value3 = (int)_biorhythmData[currDay][2];
    
    /* 각 바이오리듬 값 출력 */
    [physical setText:[NSString stringWithFormat:@"%d", value1]];
    [sensitivity setText:[NSString stringWithFormat:@"%d", value2]];
    [intellectual setText:[NSString stringWithFormat:@"%d", value3]];

	[birthDate release];
//	[currentDate release];
}

- (void)reCalcBiorhythmData:(NSDateComponents*)birthDate 
			 andCurrentDate:(NSDateComponents*)currentDate
{
    /* 현재 설정된 날짜의 1일 부터 생일 사이의 날수를 구한다. */ 
    NSDateComponents *firstDate = [[NSDateComponents alloc] init];
    [firstDate setYear:[currentDate year]];
    [firstDate setMonth:[currentDate month]];
    [firstDate setDay:1];
    
    NSDate *tempDay = [[NSCalendar currentCalendar] dateFromComponents:firstDate];
    NSDate *birthDay = [[NSCalendar currentCalendar] dateFromComponents:birthDate];
    
    NSTimeInterval ti = [tempDay timeIntervalSinceDate:birthDay];
    [firstDate release];
	
    /* 현재 설정된 날짜의 1일까지 총 일수를 구한다 */
    double days = ceil(fabs(ti) / ONEDAY_SECOND);
    
    /* 한 달치의 바이오리듬 데이터를 구한다 */
    static const double bioPeriod[MAX_BIORHYTHMDATATYPE] = {
        23.0, 28.0, 33.0	// 신체, 감성, 지성
    }; 
    
    for (int i = 0; i < 31; i++) {
        for(int j = 0; j < MAX_BIORHYTHMDATATYPE; j++) {
            _biorhythmData[i][j] = sin((days/bioPeriod[j]) * 2 * PI) * 100;
        }
        days += 1.0;
    }
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField { 
	[theTextField resignFirstResponder]; 
	
	return YES; 	
} 

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [super dealloc];
	[_timer release];
}

@end
