//
//  FingerDrawForImageViewController.m
//  FingerDrawForImage
//
//  Created by 유동근 on 09. 04. 27.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "FingerDrawForImageAppDelegate.h"
#import "FingerDrawForImageViewController.h"
#import "MyUIImageView.h"
#import "MyUIView.h"

@implementation FingerDrawForImageViewController

@synthesize _viewCount;


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

-(UIView*)viewForZoomingInScrollView:(UIScrollView*)scrollView
{
	NSArray* array = [scrollView subviews];
	const int index = _viewCount-1;				// last index
	MyUIImageView* imageView = [array objectAtIndex:index];
	return imageView;
}

-(void)scrollViewDidEndZooming:(UIScrollView*)scrollView withView:(UIView*)view atScale:(float)scale
{
}

// Implement loadView to create a view hierarchy programmatically, without using a nib.
//- (void)loadView {
////	[[UIApplication sharedApplication] setStatusBarHidden:YES animated:YES];    
//	UIScreen* screen = [UIScreen mainScreen];
//	CGRect frame = [screen applicationFrame];
//	
//	//----------------------------------------------------------------------------
//	UIScrollView* scrollView = [[UIScrollView alloc] initWithFrame:frame];
//	[scrollView setScrollEnabled:YES];
//	[scrollView setMaximumZoomScale:2.0f];
//	[scrollView setMinimumZoomScale:0.5f];
//	[scrollView setDelegate:self];
//	//----------------------------------------------------------------------------
//	
//	NSArray* arrImgName = [NSArray arrayWithObjects:
//						   @"sample3.jpg", 
//						   @"sample.jpg", 
//						   @"sample1.jpg", 
//						   @"sample2.jpg", 
//						   nil];
//	//----------------------------------------------------------------------------
//	for (NSString* imgName in arrImgName)
//	{
//		UIImage* img = [UIImage imageNamed:imgName];
//		MyUIImageView* imageView = [[MyUIImageView alloc] initWithImage:img];
//		[imageView setUserInteractionEnabled:YES];
//		[img release];
//		
//		[imageView setAlpha:0.0];
//		[scrollView addSubview:imageView];
//		[imageView release];
//	}
//	
//	self.view = scrollView;
//	//----------------------------------------------------------------------------
//	NSArray* subviews = [scrollView subviews];
//	_viewCount = [subviews count];
//	const int index = _viewCount-1;				// last index
//	MyUIImageView* imageView = [subviews objectAtIndex:index];
//	UIImage* img = imageView.image;
//	CGSize imgSize = [img size];
//	//----------------------------------------------------------------------------	
//	[scrollView setContentSize:imgSize];
//	//----------------------------------------------------------------------------
//	[imageView setAlpha:1.0];
//	//----------------------------------------------------------------------------
//	[scrollView release];
//}

-(BOOL)shouldAutorotateToInterfaceOrientation:
			(UIInterfaceOrientation)interfaceOrientation
{
//	if (interfaceOrientation == UIInterfaceOrientationPortrait ||
//		interfaceOrientation == UIInterfaceOrientationLandscapeLeft)
//		return YES;
//	else
//		return NO;
	return YES;
}

-(void)willRotateToInterfaceOrientation:
			(UIInterfaceOrientation)toInterfaceOrientation 
			duration:(NSTimeInterval)duration
{
	[self arrangColorPalette:NO withDir:toInterfaceOrientation];
}
/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [super dealloc];
}

- (void)arrangColorPalette:(BOOL)bCreateColorPalette withDir:(UIInterfaceOrientation) orientation
{
#define COLOR_PAL_WIDTH		(30)
#define COLOR_PAL_MARGIN	(20)
	BOOL bVert = (orientation != UIInterfaceOrientationLandscapeLeft &&
				  orientation != UIInterfaceOrientationLandscapeRight);
	FingerDrawForImageAppDelegate* appDelegate = 
					(FingerDrawForImageAppDelegate*)
						[[UIApplication sharedApplication] delegate];
	
	UIWindow* window = [appDelegate window];
	CGRect bounds = [window frame];
	CGPoint org = bounds.origin;
	if (bVert)
	{
		org.y = org.y + bounds.size.height - COLOR_PAL_WIDTH - COLOR_PAL_MARGIN;
		org.x = org.x + COLOR_PAL_MARGIN;
	}
	else
	{
		org.x = org.x + COLOR_PAL_MARGIN;
		org.y = org.y + COLOR_PAL_MARGIN;
	}
	
	float colors[][4] = {{1.0f, 0.0f, 0.0f, 1.0f},
						{0.0f, 1.0f, 0.0f, 1.0f},
						{0.0f, 0.0f, 1.0f, 1.0f},
						{0.0f, 0.0f, 0.0f, 1.0f},
						};
	const int colorCount = (sizeof(colors)/sizeof(colors[0]));
	
	for (int i = 0; i < colorCount ;i++)
	{
		CGRect rectPalette = CGRectMake(org.x, org.y, COLOR_PAL_WIDTH, COLOR_PAL_WIDTH);
		if (bCreateColorPalette == YES)
		{
			CGColorRef color = CGColorCreateGenericRGB(colors[i][0], 
													   colors[i][1], 
													   colors[i][2], colors[i][3]);
			//----------------------------------------------------------------------------
			UIColorView* colorView = [[UIColorView alloc] initWithFrame:rectPalette 
														   andWithColor:color];
			colorView.backgroundColor = [UIColor whiteColor];
			[window addSubview:colorView];
			[colorView setAlpha:0.4f];
			[colorView release];
			//----------------------------------------------------------------------------
		}
		else {
			UIView* colorView = [[window subviews] objectAtIndex:1+i];	// 1은 scrollview
			[colorView setFrame:rectPalette];
		}
		if (bVert)
		{
			org.x += COLOR_PAL_WIDTH;
			org.x += COLOR_PAL_MARGIN;
		}
		else
		{
			org.y += COLOR_PAL_WIDTH;
			org.y += COLOR_PAL_WIDTH;
		}
	}
}

@end
