//
//  FingerDrawForImageViewController.m
//  FingerDrawForImage
//
//  Created by 유동근 on 09. 04. 27.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "FingerDrawForImageViewController.h"
#import "MyUIImageView.h"

@implementation FingerDrawForImageViewController

@synthesize _viewCount;


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

-(UIView*)viewForZoomingInScrollView:(UIScrollView*)scrollView
{
	NSArray* array = [scrollView subviews];
	const int index = _viewCount-1;				// last index
	MyUIImageView* imageView = [array objectAtIndex:index];
	return imageView;
}

-(void)scrollViewDidEndZooming:(UIScrollView*)scrollView withView:(UIView*)view atScale:(float)scale
{
}

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
//	[[UIApplication sharedApplication] setStatusBarHidden:YES animated:YES];    
	UIScreen* screen = [UIScreen mainScreen];
	CGRect frame = [screen applicationFrame];
	
	//----------------------------------------------------------------------------
	UIScrollView* scrollView = [[UIScrollView alloc] initWithFrame:frame];
	[scrollView setScrollEnabled:YES];
	[scrollView setMaximumZoomScale:2.0f];
	[scrollView setMinimumZoomScale:0.5f];
	[scrollView setDelegate:self];
	//----------------------------------------------------------------------------
	
	NSArray* arrImgName = [NSArray arrayWithObjects:
						   @"sample3.jpg", 
						   @"sample.jpg", 
						   @"sample1.jpg", 
						   @"sample2.jpg", 
						   nil];
	//----------------------------------------------------------------------------
	for (NSString* imgName in arrImgName)
	{
		UIImage* img = [UIImage imageNamed:imgName];
		MyUIImageView* imageView = [[MyUIImageView alloc] initWithImage:img];
		[imageView setUserInteractionEnabled:YES];
		[img release];
		
		[imageView setAlpha:0.0];
		[scrollView addSubview:imageView];
		[imageView release];
	}
	
	self.view = scrollView;
	//----------------------------------------------------------------------------
	NSArray* subviews = [scrollView subviews];
	_viewCount = [subviews count];
	const int index = _viewCount-1;				// last index
	MyUIImageView* imageView = [subviews objectAtIndex:index];
	UIImage* img = imageView.image;
	CGSize imgSize = [img size];
	//----------------------------------------------------------------------------	
	[scrollView setContentSize:imgSize];
	//----------------------------------------------------------------------------
	[imageView setAlpha:1.0];
	//----------------------------------------------------------------------------
	[scrollView release];
	//----------------------------------------------------------------------------
	[self setTitle:@"Finger Draw"];
	UIBarButtonItem* buttonItem = [[[UIBarButtonItem alloc] 
									initWithTitle:@"선선택"
									style:UIBarButtonItemStylePlain 
									target:self 
									action:@selector(goSelectPen)]
								   autorelease];
	[[self navigationItem] setRightBarButtonItem:buttonItem animated:YES];
	//----------------------------------------------------------------------------
	NSArray* buttonNames = [NSArray arrayWithObjects:@"첫번째",@"두번째",@"세번째",@"네번째",nil];
	UISegmentedControl* segControl = [[UISegmentedControl alloc] initWithItems:buttonNames];
//	[segControl setMomentary:YES];
	[segControl setSegmentedControlStyle:UISegmentedControlStyleBar];
	[segControl setSelectedSegmentIndex:0];
	[segControl addTarget:self action:@selector(switchImageView:)
		 forControlEvents:UIControlEventValueChanged];
	self.navigationItem.titleView = segControl;
//	CGRect rect = CGRectMake(10.0, 20.0, 150.0, 37.0);
//	UIButton* button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
//	button.frame = rect;
//	self.navigationItem.titleView = button;
	//----------------------------------------------------------------------------
	subviews = [scrollView subviews];
	int tag = _viewCount;
	for (UIView* view in subviews)
		[view setTag:tag--];
}

-(void) goSelectPen
{
	NSArray* objs = [[NSBundle mainBundle]
					 loadNibNamed:@"ColorViewController"
					 owner:self options:NULL];
	if (0 < [objs count])
	{
		UIViewController* viewController = [objs objectAtIndex:0];
		viewController.title = @"선 선택";
		[self.navigationController pushViewController:viewController animated:YES];
	}
}

-(void)switchImageView:(id)sender
{
	int tag = [sender selectedSegmentIndex]+1;
	//---------------------------------------------------------------------------
	NSArray* subviews = [self.view subviews];
	const int index = _viewCount-1;				// last index
	UIImageView* currview = (UIImageView*)[subviews objectAtIndex:index];
	UIImageView* nextview = (UIImageView*)[self.view viewWithTag:tag];
	if (currview == nextview)
		return;
	
	//---------------------------------------------------------------------------
	CGContextRef context = UIGraphicsGetCurrentContext();
	[UIView beginAnimations:nil context:context];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
	[UIView setAnimationDuration:1.0];
			
	[currview setAlpha:0.5];
	[nextview setAlpha:1.0];
			
	[UIView commitAnimations];
	
	[currview setAlpha:0.0f];

	[self.view bringSubviewToFront:nextview];
	//----------------------------------------------------------------------------
	UIImage* img = [nextview image];
	CGSize imgSize = [img size];
	[(UIScrollView*)self.view setContentSize:imgSize];
}

-(BOOL)shouldAutorotateToInterfaceOrientation:
			(UIInterfaceOrientation)interfaceOrientation
{
//	if (interfaceOrientation == UIInterfaceOrientationPortrait ||
//		interfaceOrientation == UIInterfaceOrientationLandscapeLeft)
//		return YES;
//	else
//		return NO;
	return NO;
}

-(void)willRotateToInterfaceOrientation:
			(UIInterfaceOrientation)toInterfaceOrientation 
			duration:(NSTimeInterval)duration
{
}
/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [super dealloc];
}

//--------------------------------------------------------------------------------------------------
- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingImage:(UIImage *)image editingInfo:(NSDictionary *)editingInfo
{
	UIScrollView* scrollView = (UIScrollView*) self.view;
	NSArray* subviews = [scrollView subviews];
	for (UIView* view in subviews)
	{
		[view removeFromSuperview];
	}
	MyUIImageView* imageView = [[MyUIImageView alloc] initWithImage:image];
	[imageView setUserInteractionEnabled:YES];
	
	[scrollView addSubview:imageView];
	[imageView release];
	//----------------------------------------------------------------------------	
	CGSize imgSize = [image size];
	[scrollView setContentSize:imgSize];
	//----------------------------------------------------------------------------	
	_viewCount = 1;
	self.navigationItem.titleView = nil;
	//----------------------------------------------------------------------------	
	[self imagePickerControllerDidCancel:picker];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
	[self.tabBarController setSelectedIndex:0];
}

@end
