//
//  theWorldViewController.m
//  theWorld
//
//  Created by 유동근 on 09. 05. 22.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "theWorldViewController.h"

@implementation theWorldViewController


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
    }
    return self;
}
 */

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
	[super initWithStyle:UITableViewStyleGrouped];
	[super loadView];
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	NSString *path = [[[NSBundle mainBundle] resourcePath] stringByAppendingString:@"/theworld.txt"];
	NSString *contents = [NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:nil];
	NSMutableArray* array = [[NSMutableArray alloc] init];
	[array addObjectsFromArray:[contents componentsSeparatedByString:@"\n"]];
	
	arraySectionTitles = [[NSMutableArray alloc] init];
	arraySection = [[NSMutableArray alloc] init];
	int sectionCnt = 0;
	for (NSString* country in array) {
		if ([country hasPrefix:@"\t"]) {
			[arraySectionTitles addObject:[country stringByReplacingOccurrencesOfString:@"\t" 
																			 withString:@""]];
			NSMutableArray* countrys = [[NSMutableArray alloc] init];
			[arraySection addObject:countrys];
			[countrys release];
			sectionCnt++;
		}
		else {
			[[arraySection objectAtIndex:sectionCnt-1] addObject:country];
		}
	}
	
	[array release];
 
}

-(NSInteger)numberOfSectionsInTableView:(UITableView*)tableView {
	return [arraySection count];
}
-(NSInteger)tableView:(UITableView*)tableView
			numberOfRowsInSection:(NSInteger)section {
	return [[arraySection objectAtIndex:section] count];
}
-(UITableViewCell*)tableView:(UITableView*)tableView cellForRowAtIndexPath:(NSIndexPath*) indexPath {
	NSInteger row = [indexPath row];
	NSInteger section = [indexPath section];
	
	NSString* country = [[arraySection objectAtIndex:section] 
						 objectAtIndex:row];
	UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:country];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero
									   reuseIdentifier:country] autorelease];
	}
	NSArray* info = [country componentsSeparatedByString:@","];
	if ([[info objectAtIndex:0] length]) {
		NSString *path = [[[NSBundle mainBundle] resourcePath] 
						  stringByAppendingString:[info objectAtIndex:0]];
		cell.image = [UIImage imageWithContentsOfFile:path];
	}
	cell.text = [info objectAtIndex:1];
	return cell;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[arraySectionTitles release];
	[arraySection release];
    [super dealloc];
}

@end
